MAXScript Language Reference > 3ds Max Objects > Modifier : MAXWrapper and SpacewarpModifier : MAXWrapper > Modifier and SpacewarpModifier Types > Modifiers > Subdivision Surfaces >

# MeshSmooth : Modifier

    meshsmooth - superclass: modifier; super-superclass:MAXWrapper - classID: #(50, 32670)

Value > MAXWrapper > Modifier > MeshSmooth

| Modifier Classes - Quick Navigation

Constructor

    meshSmooth...

Properties

    <MeshSmooth>.subdivMethod Integer default: 2

Selects the Subdivision method to use:

0-Classic (Produces three- and four-sided facets.)

1-Quad Output (Produces only four-sided facets.)

2-NURMS (Produces Non-Uniform Rational MeshSmooth object.)

    <MeshSmooth>.Apply_To_Whole_Mesh Boolean default: true

When turned on, any sub-object selection passed up the stack is ignored and MeshSmooth is applied to the entire object.

Note that the sub-object selection is still passed up the stack to any subsequent modifiers.

    <MeshSmooth>.ignoreSel Boolean default: true

When turned on, any sub-object selection passed up the stack is ignored and MeshSmooth is applied to the entire object.

    <MeshSmooth>.oldMapping Boolean default: false

Uses the algorithm from the previous release of the program to apply MeshSmooth to the mapping coordinates.

This technique tends to distort the underlying mapping coordinates as it creates new faces and as texture coordinates shift.

    <MeshSmooth>.iterations Integer default: 0 -- animatable

The number of iterations used to smooth the mesh. Each iteration generates new faces using the vertices created from the previous iteration.

    <MeshSmooth>.smoothness Float default: 1.0 -- animatable; alias: smoothness_filter

Determines how sharp a corner must be before faces are added to smooth it.

Smoothness is calculated as the average angle of all edges connected to a vertex.

A value of 0.0 prevents the creation of any faces.

A value of 1.0 adds faces to all vertices even if they lie on a plane.

    <MeshSmooth>.useRenderIterations Boolean default: false; alias: use_render_iterations

Turn on/off use of render iterations, for using a different number of iterations at render time.

When off, the software will use the iterations value.

    <MeshSmooth>.renderIterations Integer default: 0 -- animatable; alias: render_iterations

Number of smoothing iterations to be applied to the object at render time.

    <MeshSmooth>.useRenderSmoothness Boolean default: false; alias: use_render_smoothness

Turn on/off use of render smoothness, for using a different smoothness value at render time.

When off, the software will use the smoothness value.

    <MeshSmooth>.renderSmoothness Float default: 1.0 -- animatable; alias: render_smoothness

Lets you choose a different Smoothness value to be applied to the object at render time.

    <MeshSmooth>.ignoreBackfacing Boolean default: false

When on, selection of sub-objects selects only those sub-objects whose normals are visible in the viewport.

When off (the default), selection includes all sub-objects, regardless of the direction of their normals.

    <MeshSmooth>.controlLevel Integer default: 0

Allows you to see the control mesh after one or more iterations and to edit sub-object points and edges at that level.

    <MeshSmooth>.displayCage Boolean default: false; alias: display_control_mesh

Displays awireframe gizmo that shows what the control mesh looks like after it’s been converted to polygons (if applicable) and before the smoothing occurs.

    <meshsmooth>.CageColor Point3 default: [1,0.588235,0] -- point3; Cage_Color

Displays a wireframe gizmo that shows what the control mesh looks like after it’s been converted to polygons (if applicable) and before the smoothing occurs.

    <meshsmooth>.selectedCageColor Point3 default: [0.94902,0.85098,0] -- point3; Selected_Cagwe_Color

Displays a wireframe gizmo that shows what the control mesh looks like after it’s been converted to polygons (if applicable) and before the smoothing occurs.

    <MeshSmooth>.useSoftSel Boolean default: false

Affects the action of Move, Rotate, and Scale functions within editable object or edit modifier, and the action of deformation modifiers applied to the object if they are operating on a sub-object selection.

When on,3ds Max applies a spline curve deformation to the unselected sub-objects surrounding the selection that you transform.

    <MeshSmooth>.useEdgeDist Boolean default: false

Turn on/off use Edge Distance.

    <MeshSmooth>.edgeDist Integer default: 1

Limits the region affected by the number of edges between the selection and the affected vertices.

    <MeshSmooth>.affectBackfacing Boolean default: false

When on, deselected sub-objects whose normals (or, in the case of vertices and edges, the normals of faces to which they’re attached) are facing in the opposite direction to the average normal of the selected sub-objects, are affected by the soft selection influence.

    <MeshSmooth>.falloff Float default: 20.0

Distance in current units from the center to the edge of a sphere defining the affected region.

Use higher falloff settings to achieve more gradual slopes, depending on the scale of your geometry.

    <MeshSmooth>.pinch Float default: 0.0

Raises and lowers the top point of the curve along the vertical axis. Sets the relative "pointedness" of the region.

When negative, a crater is produced instead of a point. At a setting of 0, Pinch produces a smooth transition across this axis.

    <MeshSmooth>.bubble Float default: 0.0

Expands and contracts the curve along the vertical axis. Sets the relative "fullness" of the region. Limited by Pinch, which sets a fixed starting point for Bubble.

A setting of 0 for Pinch and 1.0 for Bubble produces a maximum smooth bulge.

Negative values for Bubble move the bottom of the curve below the surface, creating a "valley" around the base of the region.

    <MeshSmooth>.strength Float default: 0.5 -- animatable

Sets the size of the added faces using a range from 0.0 to 1.0.

Values near 0.0 create small faces that are very thin and close to the original vertices and edges, values near 0.5 size faces evenly between edges, and values near 1.0 create large new faces and make the original faces very small.

    <MeshSmooth>.Relax Float default: 0.0 -- animatable

Applies a positive relax effect to smooth all vertices.

    <MeshSmooth>.limitSurface Boolean default: false; alias: project_to_limit_surface

Places all points on the "limit surface" of the MeshSmooth result, which is the surface you’d get after an infinite number of iterations.

    <MeshSmooth>.smoothResult Boolean default: false; alias: smooth_output

Applies the same smoothing group to all faces.

    <MeshSmooth>.sepByMats Boolean default: false; alias: separate_by_materials

Prevents the creation of new faces for edges between faces that do not share Material IDs.

    <MeshSmooth>.sepBySmGroups Boolean default: false; alias: separate_by_smoothing_group

Prevents the creation of new faces at edges between faces that don’t share at least one smoothing group.

    <MeshSmooth>.faceType Integer default: 1

Select the type to operate on during input conversion:

0- Faces

1- Polygons

Operate On Faces treats every triangle as a face and smooths across all edges, even invisible edges.

Operate On Polygons ignores invisible edges, treating polygons (like the quads making up a box or the cap on a cylinder) as a single face.

    <MeshSmooth>.keepConvex Boolean default: false; alias: keep_input_faces_convex

Keeps all input polygons convex.

Selecting this option causes non-convex polygons to be handled as a minimum number of separate faces, each of which is convex.

    <MeshSmooth>.update Integer default: 0; alias: update_options

Set update options:

0- Always update

1- Update when rendering

2- Update Manually

    <MeshSmooth>.reset Integer default: 0

Select reset settings:

0- Reset all levels

1- Reset this level

Note

The edge and vertex weight properties are not accessible to MAXScript.

#### See Also

- TurboSmooth : Modifier

- HSDS_Modifier: Modifier

- Quadify_Mesh : Modifier

- Subdivide : Modifier

- Tessellate : Modifier

- Modifier Common Properties, Operators, and Methods

- MAXWrapper Common Properties, Operators, and Methods

- Value Common Properties, Operators, and Methods